//package acs.bottom;
package clarion.acs.wm;
import java.util.Vector;
import clarion.system.*;
import clarion.common.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class is to implement the concept of working memory item in goal structure.
 * <li> summary of the important methods. <br>
 * <ol>
 * </ol>
 * </ul>
 * <li> Role in the CLARION model <br>
 * This class implements the working memory items those compose the working memory.
 * <li> Usage of this class. <br>
 * It is instantiated inside a <em>WM</em> object.
 * </ul>
 * @author Xi Zhang
 *
 */

public class WMItem{

  /** indicates if it is a flag item. */
  protected boolean flag;
  /** the chunk stored in this slot. */
  protected Chunk chunk;

  /** concstructor.
   *  @param flag the flag indicates it is a flag item or not.
   *  @param chunk the chunk to store into this slot. */
  public WMItem( boolean flag, Chunk chunk )
  {
     this.flag = flag;
     this.chunk = chunk;
  }

  /** Returns if it is a flag item. */
  public boolean isFlagItem()
  {
     return flag;
  }

  /** Returns the chunk storeed. */
  public Chunk getChunk()
  {
     return chunk;
  }

  /** Sets the flag indicating it is a flag item or not. */
  public void setFlag( boolean val )
  {
     flag = val;
  }

  /** Sets chunk into this slot.
   *  @param chunk the chunk to store into this slot. */
  public void setChunk( Chunk chunk )
  {
     this.chunk = chunk;
  }

  /** methods from class <em>Object</em> */
  public Object clone() throws CloneNotSupportedException
  {
     WMItem item = new WMItem( flag, (Chunk)chunk.clone() );
     return item;
  }

}