package clarion.options.dims;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class is to show the top-level screen of configuring Dimension Information
 * by GUI. It extends the base class <em>GuiTemplate</em>. It contains the following
 * configuration entries: Input Dimensions, Output Dimensions and Goal Parameter
 * Dimensions.
 *
 * <li> summary of the important methods. <br>
 * <ol>
 * <li> public void addActionListeners( final JFrame mainFrame ): event listeners
 * for the buttons.
 * </ol>
 * </ul>
 * <li> Role in the CLARION model <br>
 * This class is to control the process of configuring the Dimension Information
*  by GUI (on-line configuration).
 * <li> Usage of this class. <br>
 * It is instantiated inside a <em>GuiClarion</em> object.
 * </ul>
 * @author Xi Zhang
 *
 */


public class GuiDims extends GuiTemplate{

  String buttonTexts[] = { "Input Dimensions", "Output Dimensions", "Goal Parameter Dimensions" };
  String frameNames[] = { "INPUT DIMENSIONS", "OUTPUT DIMENSIONS", "Goal Parameter DIMENSIONS" };
  int[] widths = { 480, 480, 480 };
  int[] heights = { 6400, 1600, 1600 };
  int[] itemNums = { 300, 60, 60 };
  SelectionTemplate dims[];

  public GuiDims( int num )
  {
     super( num, "SPECIFICATION OF I/O DIMENSIONS" );
     setButtonTexts( buttonTexts );
     dims = new SelectionTemplate[ OPT_NUM ];
     for( int i = 0; i < OPT_NUM; i++ )
          dims[i] = new SelectionDims(this, widths[i], heights[i], frameNames[i], itemNums[i], i, manager);
     //dims[OPT_NUM-1] = new SelectionDimNacsControl( this, widths[OPT_NUM-1], heights[OPT_NUM-1], manager );
  }

  public void update()
  {
  }

  /** event listeners for the buttons. */
  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int idx = i;
          optButtons[ idx ].addActionListener(  new  ActionListener(){
                  public void actionPerformed( ActionEvent e ){
                      activeButtonIdx = idx;
                      dims[idx].setEnabled( true );
                      dims[idx].setVisible( true );
                      setEnabled( false );
                 }
             } );
     }
  }

}
