package clarion.options.rt;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class is to show the top-level screen of configuring Response Time by GUI.
 * It extends the base class <em>GuiTemplate</em>.  It contains the following
 * configuration entries: Response Time Formulas and Parameters Settings.
 *
 * <li> summary of the important methods. <br>
 * <ol>
 * <li> public void addActionListeners( final JFrame mainFrame ): event listeners
 * for the buttons.
 * </ol>
 * </ul>
 * <li> Role in the CLARION model <br>
 * This class is to control the process of configuring the Response Time by GUI
 * (on-line configuration).
 * <li> Usage of this class. <br>
 * It is instantiated inside a <em>GuiClarion</em> object.
 * </ul>
 * @author Xi Zhang
 *
 */

public class GuiRT extends GuiTemplate{

  final int SUB_OPT_NUMS[] = {  3, 9 };
  String buttonTexts[] = {
     "Options for Formulas", "Parameters Settings",
  };
  SelectionTemplate subSelections[];

  public GuiRT( int num )
  {
      super( num, "OPTIONS FOR RESPONSE TIME DETERMINATION" );
      setButtonTexts( buttonTexts );
  }

  /** event listeners for the buttons. */
  public void addActionListeners( final JFrame mainFrame )
  {
      for( int i = 0; i < OPT_NUM; i++ ){
           final int idx = i;
           optButtons[ idx ].addActionListener(  new  ActionListener(){
                            public void actionPerformed( ActionEvent e ){
                               activeButtonIdx = idx;
                               subSelections[idx].setEnabled( true );
                               subSelections[idx].setVisible( true );
                            }
                    } );
      }
  }
}
