package clarion.options.rt;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import clarion.system.*;
import clarion.options.*;
import clarion.options.transfer.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class extends the <tt>SelectionTemplate</tt> class and is the class
 * for configuration of options relevant to Respones Time calculation by GUI.
 * It contains the options such as the formula of overall RT, overall bottom level RT,
 * overall top level RT, perceptual time, decision time, activation time for both
 * bottom level and top level, RT in NACS such as associative rule application,
 * chunk retrieval and AMN one-pass time.
 *
 * <li> summary of the important methods <br>
 * <ol>
 * <li> public void initGui(): initialize the GUI components in this frame.
 * </ol>
 * </ul>
 * <li> Usage of this class. <br>
 * It is part of GUI of overall CLARION configuration and it is instantiated in
 * <tt>GuiRT</tt> class.
 * </ul>
 * @author Xi Zhang
 *
 */

public class SelectionRT extends SelectionTemplate {
 JFrame superFrame;

 JLabel capLabel = new JLabel();
 // overall.
 JPanel overPanel = new JPanel();
 JLabel overLabel = new JLabel();
 JLabel overLabel01 = new JLabel();
 JLabel overLabel11 = new JLabel();
 JLabel overLabel12 = new JLabel();
 JButton[] overUDButtons = new JButton[2]; {
    overUDButtons[0] = new JButton();
    overUDButtons[1] = new JButton();
 }
 JRadioButton[] overButtons = new JRadioButton[2]; {
   overButtons[0] = new JRadioButton();
   overButtons[1] = new JRadioButton();
 }
 // BL overall
 JPanel blPanel = new JPanel();
 JLabel blLabel = new JLabel();
 JLabel blLabel11 = new JLabel();
 JLabel blLabel1 = new JLabel();
 JButton[] blUDButtons = new JButton[2]; {
    blUDButtons[0] = new JButton();
    blUDButtons[1] = new JButton();
 }
 JRadioButton[] blButtons = new JRadioButton[2]; {
   blButtons[0] = new JRadioButton();
   blButtons[1] = new JRadioButton();
 }
 // TL overall
 JPanel tlPanel = new JPanel();
 JLabel tlLabel1 = new JLabel();
 JLabel tlLabel11 = new JLabel();
 JLabel tlLabel = new JLabel();
 JButton[] tlUDButtons = new JButton[2]; {
    tlUDButtons[0] = new JButton();
    tlUDButtons[1] = new JButton();
 }
 JRadioButton[] tlButtons = new JRadioButton[2]; {
   tlButtons[0] = new JRadioButton();
   tlButtons[1] = new JRadioButton();
 }
 // parameter
 JPanel paramPanel = new JPanel();
 JLabel paramLabel = new JLabel();
 JLabel ptblLabel = new JLabel();
 JTextField ptblField = new JTextField();
 JLabel dtblLabel = new JLabel();
 JTextField dtblField = new JTextField();
 JLabel atblLabel = new JLabel();
 JTextField atblField = new JTextField();
 // PT_TL
 JLabel pttlLabel = new JLabel();
 JLabel pttlLabel11 = new JLabel();
 JButton[] pttlUDButtons = new JButton[2]; {
    pttlUDButtons[0] = new JButton();
    pttlUDButtons[1] = new JButton();
 }
 JRadioButton[] pttlButtons = new JRadioButton[2]; {
   pttlButtons[0] = new JRadioButton();
   pttlButtons[1] = new JRadioButton();
 }
 // DT_TL
 JLabel dttlLabel = new JLabel();
 JLabel dttlLabel11 = new JLabel();
 JLabel dttlLabel12 = new JLabel();
 JLabel dttlLabel13 = new JLabel();
 JLabel dttlLabel14 = new JLabel();
 JTextField[][] dttlFields = new JTextField[2][]; {
     dttlFields[0] = new JTextField[3];
     dttlFields[0][0] = new JTextField();
     dttlFields[0][1] = new JTextField();
     dttlFields[0][2] = new JTextField();
 }
 JButton[] dttlUDButtons = new JButton[2]; {
    dttlUDButtons[0] = new JButton();
    dttlUDButtons[1] = new JButton();
 }
 JRadioButton[] dttlButtons = new JRadioButton[2]; {
   dttlButtons[0] = new JRadioButton();
   dttlButtons[1] = new JRadioButton();
 }
 // AT_TL
 JLabel attlLabel = new JLabel();
 JLabel attlLabel1 = new JLabel();
 JButton[] attlUDButtons = new JButton[2]; {
    attlUDButtons[0] = new JButton();
    attlUDButtons[1] = new JButton();
 }
 // associative rule
 JLabel assocLabel = new JLabel();
 JLabel assocLabel11 = new JLabel();
 JLabel assocLabel12 = new JLabel();
 JLabel assocLabel13 = new JLabel();
 JTextField[][] assocFields = new JTextField[2][]; {
     assocFields[0] = new JTextField[2];
     assocFields[0][0] = new JTextField();
     assocFields[0][1] = new JTextField();
 }
 JButton[] assocUDButtons = new JButton[2]; {
    assocUDButtons[0] = new JButton();
    assocUDButtons[1] = new JButton();
 }
 JRadioButton[] assocButtons = new JRadioButton[2]; {
   assocButtons[0] = new JRadioButton();
   assocButtons[1] = new JRadioButton();
 }
 // chunk.
 JLabel chunkLabel = new JLabel();
 JLabel chunkLabel11 = new JLabel();
 JLabel chunkLabel12 = new JLabel();
 JLabel chunkLabel13 = new JLabel();
 JTextField[][] chunkFields = new JTextField[2][]; {
     chunkFields[0] = new JTextField[2];
     chunkFields[0][0] = new JTextField();
     chunkFields[0][1] = new JTextField();
 }
 JButton[] chunkUDButtons = new JButton[2]; {
    chunkUDButtons[0] = new JButton();
    chunkUDButtons[1] = new JButton();
 }
 JRadioButton[] chunkButtons = new JRadioButton[2]; {
   chunkButtons[0] = new JRadioButton();
   chunkButtons[1] = new JRadioButton();
 }
 // amn.
 JLabel amnLabel = new JLabel();
 JLabel amnLabel11 = new JLabel();
 JTextField[][] amnFields = new JTextField[2][]; {
     amnFields[0] = new JTextField[1];
     amnFields[0][0] = new JTextField();
 }
 JButton[] amnUDButtons = new JButton[2]; {
    amnUDButtons[0] = new JButton();
    amnUDButtons[1] = new JButton();
 }
 JRadioButton[] amnButtons = new JRadioButton[2]; {
   amnButtons[0] = new JRadioButton();
   amnButtons[1] = new JRadioButton();
 }
 // return buttons.
 JButton returnButton = new JButton();

 public SelectionRT( JFrame superFrame, int width, int height, TransferManager manager )
  {
    super( superFrame, width, height, manager );
    initGui();
  }

 /** initialize the GUI components in this frame. */
 public void initGui()
 {
    final int OVER = 0, OVER_BL = 1, OVER_TL = 2, PT_BL = 3, DT_BL = 4, AT_BL = 5;
    final int PT_TL = 6, DT_TL = 7, AT_TL = 8, ASSOC = 9, CHUNK = 10, AMN_PASS = 11;

    options = manager.getOptions( Global.RT, 0, 0, 0, 0, 0 );
    setSize( 700, 720 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    // caption.
    initLabel( capLabel, "RESPONSE TIME  OPTIONS", new java.awt.Font("Dialog", 1, 17),
               SwingConstants.CENTER, new Rectangle(175, 0, 277, 27) );
    // overall panel
    initPanel( overPanel, BORDER, null, new Rectangle(10, 36, 270, 225));
    initLabel( overLabel01, "( specify f in RT = f( RT_BL, RT_TL )",new Rectangle(12, 24, 206, 17) );
    Rectangle[] overUDRects = { new Rectangle(24, 150, 160, 20), new Rectangle(24, 180, 160, 20) };
    String[] overUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.OVER_RT ),
                               TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.OVER_RT ) };
    initUserDefinedBlock( overPanel, overUDButtons, overUDRects, overUDTexts );
    initLabel( overLabel11, "RT = RT_BL or RT_TL", new Rectangle(24, 70, 206, 17) );
    initLabel( overLabel12, "( if stochastic combination is used )", new Rectangle(24, 90, 206, 17) );
    String[] overTexts = {"default", "user defined" };
    Rectangle[] overRects = {new Rectangle(10, 50, 74, 17),new Rectangle(10, 120, 100, 17)};
    initButtonBlock( overPanel, overLabel, "Overall response time", new Rectangle(6, 4, 144, 17),
                     overButtons, overTexts, overRects, options[OVER], 1, overUDButtons );
    // BL overall
    initPanel( blPanel, BORDER, null, new Rectangle(10, 288, 270, 251));
    Rectangle[] blUDRects = { new Rectangle(24, 130, 160, 20), new Rectangle(24, 160, 160, 20) };
    String[] blUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.BL_RT ),
                           TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.BL_RT ) };
    initUserDefinedBlock( blPanel, blUDButtons, blUDRects, blUDTexts );
    initLabel( blLabel1,"( f_BL in RT_BL = f_BL( PT_BL, DT_BL, AT_BL )",new Rectangle(6, 20, 263, 17));
    initLabel( blLabel11, "RT_BL = PT_BL + DT_BL + AT_BL", new Rectangle(23, 71, 200, 17));
    String[] blTexts = {"default", "user defined" };
    Rectangle[] blRects = {new Rectangle(8, 50, 64, 17),new Rectangle(8, 100, 100, 17)};
    initButtonBlock( blPanel, blLabel, "Response time of the bottom level ", new Rectangle(3, 4, 214, 17),
                     blButtons, blTexts, blRects, options[OVER_BL], 1, blUDButtons );
    // TL overall
    initPanel( tlPanel, BORDER, null, new Rectangle(10, 580, 270, 252));
    Rectangle[] tlUDRects = { new Rectangle(24, 140, 160, 20), new Rectangle(24, 170, 160, 20) };
    String[] tlUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.TL_RT ),
                               TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.TL_RT ) };
    initUserDefinedBlock( tlPanel, tlUDButtons, tlUDRects, tlUDTexts );
    initLabel( tlLabel1,"( f_TL in RT_TL = f_TL( PT_TL, DT_TL, AT_TL )",new Rectangle(6, 20, 260, 17));
    initLabel( tlLabel11,"RT_TL = PT_TL + DT_TL + AT_TL",new Rectangle(28, 70, 200, 17));
    String[] tlTexts = {"default", "user defined" };
    Rectangle[] tlRects = {new Rectangle(8, 50, 64, 17),new Rectangle(8, 110, 100, 17)};
    initButtonBlock( tlPanel, tlLabel, "Response time of the  top level", new Rectangle(3, 4, 218, 17),
                     tlButtons, tlTexts, tlRects, options[OVER_TL], 1, tlUDButtons );
    // parameter panel
    initPanel( paramPanel, BORDER, null,new Rectangle(290, 38, 360, 794));
    initLabel( paramLabel, "Response time parameters", new Rectangle(4, 4, 218, 17) );
    // PT_BL
    initLabel( ptblLabel, "PT_BL =", new Rectangle(13, 30, 49, 17));
    initField( ptblField, String.valueOf(options[PT_BL].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(63, 29, 39, 17), 5, options[PT_BL], 0, 0 );
    // DT_BL
    initLabel( dtblLabel,"DT_BL =", new Rectangle(119, 29, 51, 17));
    initField( dtblField, String.valueOf(options[DT_BL].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(170, 28, 35, 17), 5, options[DT_BL], 0, 0 );
    // AT_BL
    initLabel( atblLabel, "AT_BL =", new Rectangle(222, 29, 51, 17));
    initField( atblField, String.valueOf(options[AT_BL].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(273, 28, 32, 17), 5, options[AT_BL], 0, 0 );
    // PT_TL
    initLabel( pttlLabel11, "PT_TL = PT_BL +100", new Rectangle(107, 76, 134, 17) );
    Rectangle[] pttlUDRects = { new Rectangle(36, 120, 160, 17), new Rectangle(36, 140, 160, 17) };
    String[] pttlUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.PT_TL ),
                               TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.PT_TL ) };
    initUserDefinedBlock( paramPanel, pttlUDButtons, pttlUDRects, pttlUDTexts );
    String[] pttlTexts = {"default", "user defined" };
    Rectangle[] pttlRects = {new Rectangle(19, 75, 65, 17),new Rectangle(19, 98, 100, 17)};
    initButtonBlock( paramPanel, pttlLabel, "PT_TL", new Rectangle(16, 55, 65, 17),
                     pttlButtons, pttlTexts, pttlRects, options[PT_TL], 1, pttlUDButtons );
    // DT_TL
    Rectangle[] dttlUDRects = { new Rectangle(36, 276, 160, 17), new Rectangle(36, 296, 160, 17) };
    String[] dttlUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.DT_TL ),
                               TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.DT_TL ) };
    initUserDefinedBlock( paramPanel, dttlUDButtons, dttlUDRects, dttlUDTexts );
    String[] dttlTexts = {"default", "user defined" };
    Rectangle[] dttlRects = {new Rectangle(20, 192, 65, 17),new Rectangle(20, 256, 100, 17)};
    initButtonBlock( paramPanel, dttlLabel, "DT_TL", new Rectangle(16, 171, 43, 17),
                     dttlButtons, dttlTexts, dttlRects, options[DT_TL], dttlFields, 1, dttlUDButtons );
    initLabel( dttlLabel14,"DT_TL = action-time +t0 * 1 / rule-bla + t1 * 1 / chunk-bla",
               new Rectangle(36, 212, 314, 17) );
    initLabel( dttlLabel11, "action time =", new Rectangle(42, 234, 80, 17));
    initField( dttlFields[0][0], String.valueOf(options[DT_TL].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(122, 231, 32, 17), 5, options[DT_TL], 0, 0 );
    initLabel( dttlLabel12, "t0 =", new Rectangle(174, 234, 28, 17));
    initField( dttlFields[0][1], String.valueOf(options[DT_TL].getOptionItem(0).getParameter(1).getDoubleValue()),
               new Rectangle(202, 231, 32, 17), 5, options[DT_TL], 0, 1 );
    initLabel( dttlLabel13, "t1 =", new Rectangle(254, 234, 28, 17) );
    initField( dttlFields[0][2], String.valueOf(options[DT_TL].getOptionItem(0).getParameter(2).getDoubleValue()),
               new Rectangle(282, 232, 32, 17), 5, options[DT_TL], 0, 2 );
    // AT_TL
    initLabel( attlLabel, "AT_TL", new Rectangle(16, 320, 46, 17));
    initLabel( attlLabel1, "user defined", new Rectangle(42, 340, 100, 17));
    Rectangle[] attlUDRects = { new Rectangle(36, 340, 160, 17), new Rectangle(36, 360, 160, 17) };
    String[] attlUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.AT_TL ),
                               TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.AT_TL ) };
    initUserDefinedBlock( paramPanel, attlUDButtons, attlUDRects, attlUDTexts );
    // associative rule application time.
    Rectangle[] assocUDRects = { new Rectangle(36, 494, 160, 17), new Rectangle(36, 524, 160, 17) };
    String[] assocUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.ASSOC_APP ),
                              TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.ASSOC_APP ) };
    initUserDefinedBlock( paramPanel, assocUDButtons, assocUDRects, assocUDTexts );
    String[] assocTexts = { "default", "user defined" };
    Rectangle[] assocRects = {new Rectangle(25, 426, 65, 17),new Rectangle(24, 470, 100, 17)};
    initButtonBlock( paramPanel, assocLabel,"Associative rule application time in GKS ",new Rectangle(16, 405, 240, 17),
                 assocButtons, assocTexts, assocRects, options[ASSOC], assocFields, 1, assocUDButtons );
    initLabel( assocLabel13,"t_a = t4 + t5 * 1 / rule-bla",new Rectangle(38, 448, 143, 17));
    initLabel( assocLabel11,"t4 =", new Rectangle(188, 448, 24, 17));
    initField( assocFields[0][0], String.valueOf(options[ASSOC].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(212, 446, 32, 17), 5, options[ASSOC], 0, 0 );
    initLabel( assocLabel12, "t5 =", new Rectangle(256, 446, 24, 17));
    initField( assocFields[0][1], String.valueOf(options[ASSOC].getOptionItem(0).getParameter(1).getDoubleValue()),
               new Rectangle(280, 446, 32, 17), 5, options[ASSOC], 0, 1 );
    // chunk retrieval time.
    Rectangle[] chunkUDRects = { new Rectangle(36, 626, 160, 17), new Rectangle(36, 646, 160, 17) };
    String[] chunkUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.CHUNK_RETR ),
                               TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.CHUNK_RETR ) };
    initUserDefinedBlock( paramPanel, chunkUDButtons, chunkUDRects, chunkUDTexts );
    String[] chunkTexts = {"default", "user defined" };
    Rectangle[] chunkRects = {new Rectangle(26, 565, 65, 17),new Rectangle(24, 604, 100, 17)};
    initButtonBlock( paramPanel, chunkLabel, "Chunk retrieval time in GKS", new Rectangle(16, 547, 154, 17),
                     chunkButtons, chunkTexts, chunkRects, options[CHUNK], chunkFields, 1, chunkUDButtons );
    initLabel( chunkLabel13,"t_c = t2 + t3 * 1 / chunk-bla", new Rectangle(43, 585, 154, 17));
    initLabel( chunkLabel11, "t2 =", new Rectangle(208, 586, 24, 17));
    initField( chunkFields[0][0], String.valueOf(options[CHUNK].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(232, 586, 32, 17), 5, options[CHUNK], 0, 0 );
    initLabel( chunkLabel12, "t3 =", new Rectangle(274, 586, 24, 17));
    initField( chunkFields[0][1], String.valueOf(options[CHUNK].getOptionItem(0).getParameter(1).getDoubleValue()),
               new Rectangle(298, 586, 32, 17), 5, options[CHUNK], 0, 1 );
    // amn one pass time.
    Rectangle[] amnUDRects = { new Rectangle(36, 740, 160, 17), new Rectangle(36, 760, 160, 17) };
    String[] amnUDTexts = { TaskClarion.getSample( TaskClarion.RT, TaskClarion.AMN_PASS ),
                            TaskClarion.getExplanation( TaskClarion.RT, TaskClarion.AMN_PASS ) };
    initUserDefinedBlock( paramPanel, amnUDButtons, amnUDRects, amnUDTexts );
    String[] amnTexts = {"default", "user defined" };
    Rectangle[] amnRects = {new Rectangle(25, 696, 65, 17),new Rectangle(26, 720, 100, 17)};
    initButtonBlock( paramPanel, amnLabel, "AMN one-pass time", new Rectangle(16, 673, 124, 17),
                     amnButtons, amnTexts, amnRects, options[AMN_PASS], amnFields, 1, amnUDButtons );
    initLabel( amnLabel11,"t_AMN =",new Rectangle(97, 696, 48, 17));
    initField( amnFields[0][0], String.valueOf(options[AMN_PASS].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(149, 696, 31, 17), 5, options[AMN_PASS], 0, 0 );
    // return buttons.
    initReturnButton( returnButton,"RETURN", new Rectangle(535, 843, 106, 25));
    // components.
    overPanel.add(overLabel, null);
    overPanel.add(overLabel01, null);
    overPanel.add(overLabel11, null);
    overPanel.add(overLabel12, null);
    tlPanel.add(tlLabel, null);
    tlPanel.add(tlLabel1, null);
    tlPanel.add(tlLabel11, null);
    blPanel.add(blLabel, null);
    blPanel.add(blLabel1, null);
    blPanel.add(blLabel11, null);
    paramPanel.add(paramLabel, null);
    paramPanel.add(ptblLabel, null);
    paramPanel.add(dtblLabel, null);
    paramPanel.add(atblLabel, null);
    paramPanel.add(pttlLabel, null);
    paramPanel.add(dttlLabel, null);
    paramPanel.add(dttlLabel14, null);
    paramPanel.add(dttlLabel11, null);
    paramPanel.add(dttlFields[0][0], null);
    paramPanel.add(dttlLabel12, null);
    paramPanel.add(dttlFields[0][1], null);
    paramPanel.add(dttlLabel13, null);
    paramPanel.add(dttlFields[0][2], null);
    paramPanel.add(attlLabel, null);
    paramPanel.add(attlLabel1, null);
    paramPanel.add(assocLabel, null);
    paramPanel.add(assocLabel13, null);
    paramPanel.add(assocLabel11, null);
    paramPanel.add(assocLabel12, null);
    paramPanel.add(chunkLabel, null);
    paramPanel.add(chunkLabel13, null);
    paramPanel.add(chunkLabel11, null);
    paramPanel.add(chunkLabel12, null);
    paramPanel.add(amnLabel, null);
    paramPanel.add(amnLabel11, null);
    paramPanel.add(assocFields[0][0], null);
    paramPanel.add(assocFields[0][1], null);
    paramPanel.add(chunkFields[0][0], null);
    paramPanel.add(chunkFields[0][1], null);
    paramPanel.add(amnFields[0][0], null);
    paramPanel.add(ptblField, null);
    paramPanel.add(dtblField, null);
    paramPanel.add(atblField, null);
    paramPanel.add(pttlLabel11, null);
    parent.add(capLabel, null);
    parent.add(overPanel, null);
    parent.add(paramPanel, null);
    parent.add(tlPanel, null);
    parent.add(blPanel, null);
    parent.add(returnButton, null);
  }
}
