package clarion.tools.linkedlist;

public interface List {

	/** Checks whether the list is empty.
	    @return <tt>true</tt> if the list is empty, <tt>false</tt> otherwise. */
	//---------------------------------------------
	public boolean isEmpty ();

	/** Counts the number of elements in the list.
	    @return the number of elements in the list. */
	//---------------------------------------------
	public int getCount ();

	/** Returns the first element in the list.
	    @return the first element in the list. */
	//---------------------------------------------
	public Object getHead ();

	/** Returns the last element in the list.
	    @return the last element in the list. */
	//---------------------------------------------
	public Object getTail ();

	/** Returns the element at the specified position in the list.
	    @param index the index of the element to return.
	    @return the element at the specified position. */
	//---------------------------------------------
	public Object getFrom (int index);

	/** Inserts an element at the beginning of the list.
	    @param element the element to be inserted. */
	//---------------------------------------------
	public void insertHead (Object element);

	/** Inserts an element at the end of the list.
	    @param element the element to be inserted. */
	//---------------------------------------------
	public void insertTail (Object element);

	/** Inserts an element at the specified position in the list.
	    @param element the element to be inserted.
	    @param index the position at which the element is to be inserted. */
	//---------------------------------------------
	public void insertAt (Object element, int index);

	/** Removes the first element from the list.
	    @return the element that was first in the list. */
	//---------------------------------------------
	public Object removeHead ();

	/** Removes the last element from the list.
	    @return the element that was last in the list. */
	//---------------------------------------------
	public Object removeTail ();

	/** Removes from the list the element at the specified location.
	    @param index the index of the element to be removed.
	    @return the element that was at the specified location. */
	//---------------------------------------------
	public Object removeFrom (int index);
}

